--******************************************************************************
--*  PivotToVert   1.0               for Max 4.2                               *
--*  by Ofer Zelichover (c) 01/2002                                            *
--*  www.tdp.nu/ofer   ;   ofer_z@hotmail.com                                  *
--*                                                                            *
--******************************************************************************
--*  You may use this script freely as you see fit.                            *
--*  You may use parts or the script as a whole in your own scripts.           *
--*  (it would be nice if you give me a credit if you do so ;))                *
--******************************************************************************
--*  This script comes with no waranty!                                        *
--*  Although I tried this script and couldn't find any problems with it, I can*
--*  in no way be held responsible for any kind of loss or damage, whether     *
--*  direct or indirect, due to the use of this script.                        *
--*                                                                            *
--*  ********************************************************************      *
--*  *** IF YOU DON'T LIKE THE ABOVE STATEMENT, DON'T USE THIS SCRIPT ***      *
--*  ********************************************************************      *
--*                                                                            *
--*  **** This script was written for max 4.2 and wasn't tested on other ****  *
--*  **** versions of max.                                               ****  *
--*                                                                            *
--*  If you find any bugs in this script, please let me know.                  *
--******************************************************************************
--* Description                                                                *
--* -------------                                                              *
--* Aligns the pivot point to the selected vertex.                             *
--*                                                                            *
--******************************************************************************
--* History, Status and Known issues                                           *
--* ----------------------------------                                         *
--* created : 10/01/2002                                                       *
--*                                                                            *
--* Known issues:                                                              *
--*                                                                            *
--*Need to add:                                                                *
--*                                                                            *
--******************************************************************************
--* Isntallation:                                                              *
--* --------------                                                             *
--*    put:                                                                    *
--*        PivotToVert.ms - anywhere                                           *
--*                                                                            *
--*   After you run the script, it will be in the customize user interface     *
--*   under "Os Tools" category. You can now assign the the script to buttons, *
--*   menus, keyboard shortcuts or quads.                                      *
--******************************************************************************

macroScript PivotToVert
	category:"Os Tools"
	buttontext:"Pivot2Vert"
	tooltip:"Align Pivot to Vert"
(
	fn alignPivotToVert = (
		if selection.count == 1 then (
			local obj = selection[1]
			case (classOf obj) of (
				line: 			if (getKnotSelection obj 1).count==1 then 
									obj.pivot=getKnotPoint obj 1 (getKnotSelection obj 1)[1]
				SplineShape: (	k=for i = 1 to obj.numSplines collect getKnotSelection obj i
								cnt = 0
								for i in k do cnt+=i.count
								if cnt==1 then (
									for i = 1 to k.count where k[i].count==1 do
										obj.pivot=getKnotPoint obj i k[i][1]
								)
							 )
				Editable_mesh: (v=(getVertSelection obj)as array
								if v.count==1 then
									obj.pivot=getVert obj (v[1])
							   )
				Editable_Poly: (v=(getVertSelection obj)as array
								if v.count==1 then
									obj.pivot=polyop.getVert obj (v[1])
							   )
			)
		)
	)

	on execute do alignPivotToVert()
) -- end of macroscript